﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using System.Diagnostics;
using System.Collections.ObjectModel;
using System.Threading;

namespace WpfApplication2
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        DateTime beginTime;
        DateTime endTime;

        public ObservableCollection<TestData> Data { get; set; }

        public Window1()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(MainWindow_Loaded);
            Data = new ObservableCollection<TestData>();
        }

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            //DataTable dt = TestData();
            //beginTime = DateTime.Now;
            //this.xamGrid.DataSource = dt.DefaultView;

            this.DataContext = this;

            Thread t = new Thread(PopulateData);
            t.IsBackground = true;
            t.Start();

            //endTime = DateTime.Now;
            //Debug.WriteLine(endTime - beginTime);
        }

        private void PopulateData()
        {
            int count = 0;

            while (true)
            {

                this.Dispatcher.BeginInvoke(new Action(() =>
                    {
                        Data.Insert(0, new TestData()
                        {
                            JobID = count.ToString(),
                            Name = "Name" + count.ToString(),
                            Time = DateTime.Now.ToString("hh:mm:ss.fff")
                        });

                    }));

                count++;

                Thread.Sleep(5000);

            }
        }

        //private DataTable TestData()
        //{
        //    const int NumberOfRecords = 10;
        //    DataTable dtData = new DataTable();
        //    dtData.Columns.Add("Column_1", typeof(string));
        //    dtData.Columns.Add("Column_2", typeof(string));
        //    dtData.Columns.Add("Column_3", typeof(int));
        //    dtData.Columns.Add("IsModified", typeof(bool));

        //    for (int i = 1; i <= NumberOfRecords; i++)
        //    {
        //        DataRow dr = dtData.NewRow();
        //        dr[0] = "Base Text " + i.ToString();
        //        dr[1] = "Some Text " + i.ToString();
        //        dr[2] = i;
        //        dtData.Rows.Add(dr);
        //    }

        //    return dtData;

        //}
        //private DataTable TestData(int numCols, int numRows)
        //{
        //    DataTable dtData = new DataTable("Table1");
        //    for (int i = 1; i <= numCols; i++)
        //    {
        //        if (i % 2 == 0)
        //        {
        //            dtData.Columns.Add("Column_" + i.ToString(), typeof(string));
        //        }
        //        else
        //        {
        //            dtData.Columns.Add("Column_" + i.ToString(), typeof(int));
        //        }

        //    }
        //    for (int i = 1; i <= numRows; i++)
        //    {
        //        DataRow dr = dtData.NewRow();
        //        for (int j = 0; j < numCols; j++)
        //        {

        //            if (j % 2 == 0)
        //            {
        //                dr[j] = i;
        //            }
        //            else
        //            {
        //                dr[j] = "SomeText" + i.ToString();
        //            }

        //        }
        //        dtData.Rows.Add(dr);
        //    }

        //    return dtData;
        //}

        private void xamDataGrid1_RecordUpdated(object sender, Infragistics.Windows.DataPresenter.Events.RecordUpdatedEventArgs e)
        {
            ((DataRowView)e.Record.DataItem).Row["IsModified"] = true;
        }
    }

    public class TestData
    {
        public string Name { get; set; }
        public string JobID { get; set; }
        public string Time { get; set; }
    }
}
